Index: /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxDispIf.cpp
===================================================================
--- /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxDispIf.cpp	(revision 95960)
+++ /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxDispIf.cpp	(revision 95961)
@@ -22,4 +22,5 @@
 #define _WIN32_WINNT 0x0601
 #include "VBoxTray.h"
+#include "VBoxTrayInternal.h"
 
 #include <iprt/alloca.h>
Index: /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxDisplay.cpp
===================================================================
--- /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxDisplay.cpp	(revision 95960)
+++ /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxDisplay.cpp	(revision 95961)
@@ -29,4 +29,5 @@
 # include <iprt/asm.h>
 #endif
+#include <iprt/log.h>
 #include <iprt/system.h>
 
Index: unk/src/VBox/Additions/WINNT/VBoxTray/VBoxDisplay.h
===================================================================
--- /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxDisplay.h	(revision 95960)
+++ 	(revision )
@@ -1,50 +1,0 @@
-/* $Id$ */
-/** @file
- * VBoxSeamless - Display notifications
- */
-
-/*
- * Copyright (C) 2006-2022 Oracle Corporation
- *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- */
-
-#ifndef GA_INCLUDED_SRC_WINNT_VBoxTray_VBoxDisplay_h
-#define GA_INCLUDED_SRC_WINNT_VBoxTray_VBoxDisplay_h
-#ifndef RT_WITHOUT_PRAGMA_ONCE
-# pragma once
-#endif
-
-/** @todo r=bird: This file has the same name as ../include/VBoxDisplay.h
- *        which some of the VBoxTray source files also wish to include.
- *
- *        The result is a certifiable mess. To quote a Tina Fey's character in
- *        Ponyo: "BAKA BAKA BAKA BAKA BAKA BAKA BAKA BAKA BAKA BAKA BAKA!!!"
- *
- *        There are too many 'ing header files here.  Most of them can be merged
- *        into VBoxTray.h (or a VBoxTrayInternal.h file).
- *
- */
-
-
-DWORD VBoxDisplayGetCount();
-DWORD VBoxDisplayGetConfig(const DWORD NumDevices, DWORD *pDevPrimaryNum, DWORD *pNumDevices, DISPLAY_DEVICE *paDisplayDevices, DEVMODE *paDeviceModes);
-
-DWORD EnableAndResizeDispDev(DEVMODE *paDeviceModes, DISPLAY_DEVICE *paDisplayDevices, DWORD totalDispNum, UINT Id, DWORD aWidth, DWORD aHeight,
-                             DWORD aBitsPerPixel, LONG aPosX, LONG aPosY, BOOL fEnabled, BOOL fExtDispSup);
-
-#ifndef VBOX_WITH_WDDM
-static bool isVBoxDisplayDriverActive(void);
-#else
-/* @misha: getVBoxDisplayDriverType is used instead.
- * it seems bad to put static function declaration to header,
- * so it is moved to VBoxDisplay.cpp */
-#endif
-
-#endif /* !GA_INCLUDED_SRC_WINNT_VBoxTray_VBoxDisplay_h */
Index: /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxDnDEnumFormat.cpp
===================================================================
--- /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxDnDEnumFormat.cpp	(revision 95960)
+++ /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxDnDEnumFormat.cpp	(revision 95961)
@@ -20,4 +20,7 @@
 *   Header Files                                                                                                                 *
 *********************************************************************************************************************************/
+#define LOG_GROUP LOG_GROUP_GUEST_DND
+#include <VBox/log.h>
+
 #include <iprt/win/windows.h>
 #include <new> /* For bad_alloc. */
Index: /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxHostVersion.cpp
===================================================================
--- /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxHostVersion.cpp	(revision 95960)
+++ /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxHostVersion.cpp	(revision 95961)
@@ -17,9 +17,11 @@
  */
 
+#include <VBox/log.h>
+#include <VBox/VBoxGuestLib.h>
+
 #include "VBoxHostVersion.h"
 #include "VBoxTray.h"
 #include "VBoxHelpers.h"
 
-#include <VBox/VBoxGuestLib.h>
 
 
Index: /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxIPC.cpp
===================================================================
--- /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxIPC.cpp	(revision 95960)
+++ /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxIPC.cpp	(revision 95961)
@@ -22,10 +22,4 @@
 *   Header Files                                                                                                                 *
 *********************************************************************************************************************************/
-#include <iprt/win/windows.h>
-#include "VBoxTray.h"
-#include "VBoxTrayMsg.h"
-#include "VBoxHelpers.h"
-#include "VBoxIPC.h"
-
 #include <iprt/asm.h>
 #include <iprt/assert.h>
@@ -35,6 +29,13 @@
 #include <iprt/list.h>
 #include <iprt/localipc.h>
+#include <iprt/log.h>
 #include <iprt/mem.h>
 #include <iprt/process.h>
+#include <iprt/win/windows.h>
+
+#include "VBoxTray.h"
+#include "VBoxTrayMsg.h"
+#include "VBoxHelpers.h"
+#include "VBoxIPC.h"
 
 
Index: /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxLA.cpp
===================================================================
--- /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxLA.cpp	(revision 95960)
+++ /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxLA.cpp	(revision 95961)
@@ -24,4 +24,5 @@
 #include <iprt/list.h>
 #include <iprt/ldr.h>
+#include <iprt/log.h>
 #include <iprt/utf16.h>
 
Index: /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxSeamless.cpp
===================================================================
--- /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxSeamless.cpp	(revision 95960)
+++ /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxSeamless.cpp	(revision 95961)
@@ -22,4 +22,5 @@
 #include <iprt/assert.h>
 #include <iprt/ldr.h>
+#include <iprt/log.h>
 #include <iprt/mem.h>
 #include <iprt/system.h>
Index: /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxTrayInternal.h
===================================================================
--- /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxTrayInternal.h	(revision 95961)
+++ /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxTrayInternal.h	(revision 95961)
@@ -0,0 +1,38 @@
+/* $Id$ */
+/** @file
+ * VBoxSeamless - Display notifications
+ */
+
+/*
+ * Copyright (C) 2006-2022 Oracle Corporation
+ *
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ */
+
+#ifndef GA_INCLUDED_SRC_WINNT_VBoxTray_Internal_h
+#define GA_INCLUDED_SRC_WINNT_VBoxTray_Internal_h
+#ifndef RT_WITHOUT_PRAGMA_ONCE
+# pragma once
+#endif
+
+DWORD VBoxDisplayGetCount();
+DWORD VBoxDisplayGetConfig(const DWORD NumDevices, DWORD *pDevPrimaryNum, DWORD *pNumDevices, DISPLAY_DEVICE *paDisplayDevices, DEVMODE *paDeviceModes);
+
+DWORD EnableAndResizeDispDev(DEVMODE *paDeviceModes, DISPLAY_DEVICE *paDisplayDevices, DWORD totalDispNum, UINT Id, DWORD aWidth, DWORD aHeight,
+                             DWORD aBitsPerPixel, LONG aPosX, LONG aPosY, BOOL fEnabled, BOOL fExtDispSup);
+
+#ifndef VBOX_WITH_WDDM
+static bool isVBoxDisplayDriverActive(void);
+#else
+/* @misha: getVBoxDisplayDriverType is used instead.
+ * it seems bad to put static function declaration to header,
+ * so it is moved to VBoxDisplay.cpp */
+#endif
+
+#endif /* !GA_INCLUDED_SRC_WINNT_VBoxTray_Internal_h */
Index: /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxVRDP.cpp
===================================================================
--- /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxVRDP.cpp	(revision 95960)
+++ /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxVRDP.cpp	(revision 95961)
@@ -18,4 +18,5 @@
 #include <iprt/assert.h>
 #include <iprt/ldr.h>
+#include <VBox/log.h>
 
 /* 0x0501 for SPI_SETDROPSHADOW */