Index: /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxHelpers.cpp
===================================================================
--- /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxHelpers.cpp	(revision 95963)
+++ /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxHelpers.cpp	(revision 95964)
@@ -117,5 +117,5 @@
                    int iNewPosX, int iNewPosY)
 {
-    DDCLOG(("nRects %d, iPrimary %d, iResized %d, NewWidth %d, NewHeight %d\n", nRects, uPrimary, uResized, iNewWidth, iNewHeight));
+    Log4Func(("nRects %d, iPrimary %d, iResized %d, NewWidth %d, NewHeight %d\n", nRects, uPrimary, uResized, iNewWidth, iNewHeight));
 
     RECTL *paNewRects = (RECTL *)alloca (sizeof (RECTL) * nRects);
@@ -140,5 +140,5 @@
         /* Find the next adjacent original rect in x positive direction. */
         unsigned iNextRect = hlpNextAdjacentRectXP(paRects, nRects, iRect);
-        DDCLOG(("next %d -> %d\n", iRect, iNextRect));
+        Log4Func(("next %d -> %d\n", iRect, iNextRect));
 
         if (iNextRect == ~0 || iNextRect == uPrimary)
@@ -154,7 +154,7 @@
         if (delta != 0)
         {
-            DDCLOG(("XP intersection right %d left %d, diff %d\n",
-                     paNewRects[iRect].right, paNewRects[iNextRect].left,
-                     delta));
+            Log4Func(("XP intersection right %d left %d, diff %d\n",
+                      paNewRects[iRect].right, paNewRects[iNextRect].left,
+                      delta));
 
             paNewRects[iNextRect].left += delta;
@@ -168,5 +168,5 @@
         /* Find the next adjacent original rect in x negative direction. */
         unsigned iNextRect = hlpNextAdjacentRectXN(paRects, nRects, iRect);
-        DDCLOG(("next %d -> %d\n", iRect, iNextRect));
+        Log4Func(("next %d -> %d\n", iRect, iNextRect));
 
         if (iNextRect == ~0 || iNextRect == uPrimary)
@@ -182,7 +182,7 @@
         if (delta != 0)
         {
-            DDCLOG(("XN intersection left %d right %d, diff %d\n",
-                     paNewRects[iRect].left, paNewRects[iNextRect].right,
-                     delta));
+            Log4Func(("XN intersection left %d right %d, diff %d\n",
+                      paNewRects[iRect].left, paNewRects[iNextRect].right,
+                      delta));
 
             paNewRects[iNextRect].left += delta;
@@ -196,5 +196,5 @@
         /* Find the next adjacent original rect in y positive direction. */
         unsigned iNextRect = hlpNextAdjacentRectYP(paRects, nRects, iRect);
-        DDCLOG(("next %d -> %d\n", iRect, iNextRect));
+        Log4Func(("next %d -> %d\n", iRect, iNextRect));
 
         if (iNextRect == ~0 || iNextRect == uPrimary)
@@ -210,7 +210,7 @@
         if (delta != 0)
         {
-            DDCLOG(("YP intersection bottom %d top %d, diff %d\n",
-                     paNewRects[iRect].bottom, paNewRects[iNextRect].top,
-                     delta));
+            Log4Func(("YP intersection bottom %d top %d, diff %d\n",
+                      paNewRects[iRect].bottom, paNewRects[iNextRect].top,
+                      delta));
 
             paNewRects[iNextRect].top += delta;
@@ -224,5 +224,5 @@
         /* Find the next adjacent original rect in x negative direction. */
         unsigned iNextRect = hlpNextAdjacentRectYN(paRects, nRects, iRect);
-        DDCLOG(("next %d -> %d\n", iRect, iNextRect));
+        Log4Func(("next %d -> %d\n", iRect, iNextRect));
 
         if (iNextRect == ~0 || iNextRect == uPrimary)
@@ -238,7 +238,7 @@
         if (delta != 0)
         {
-            DDCLOG(("YN intersection top %d bottom %d, diff %d\n",
-                     paNewRects[iRect].top, paNewRects[iNextRect].bottom,
-                     delta));
+            Log4Func(("YN intersection top %d bottom %d, diff %d\n",
+                      paNewRects[iRect].top, paNewRects[iNextRect].bottom,
+                      delta));
 
             paNewRects[iNextRect].top += delta;
@@ -256,13 +256,13 @@
         paRects[iRect].top    = paNewRects[iRect].top    - iOffsetY;
         paRects[iRect].bottom = paNewRects[iRect].bottom - iOffsetY;
-        DDCLOG((" [%d]: %d,%d %dx%d -> %d,%d %dx%d%s\n",
-                iRect,
-                paRects[iRect].left, paRects[iRect].top,
-                paRects[iRect].right - paRects[iRect].left,
-                paRects[iRect].bottom - paRects[iRect].top,
-                paNewRects[iRect].left, paNewRects[iRect].top,
-                paNewRects[iRect].right - paNewRects[iRect].left,
-                paNewRects[iRect].bottom - paNewRects[iRect].top,
-                iRect == uPrimary? " <- primary": ""));
+        Log4Func((" [%d]: %d,%d %dx%d -> %d,%d %dx%d%s\n",
+                  iRect,
+                  paRects[iRect].left, paRects[iRect].top,
+                  paRects[iRect].right - paRects[iRect].left,
+                  paRects[iRect].bottom - paRects[iRect].top,
+                  paNewRects[iRect].left, paNewRects[iRect].top,
+                  paNewRects[iRect].right - paNewRects[iRect].left,
+                  paNewRects[iRect].bottom - paNewRects[iRect].top,
+                  iRect == uPrimary? " <- primary": ""));
     }
     return;
Index: /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxHelpers.h
===================================================================
--- /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxHelpers.h	(revision 95963)
+++ /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxHelpers.h	(revision 95964)
@@ -22,13 +22,4 @@
 #endif
 
-// #define DEBUG_DISPLAY_CHANGE
-
-/** @todo r=andy WTF? Remove this!! */
-#ifdef DEBUG_DISPLAY_CHANGE
-#   define DDCLOG(a) Log(a)
-#else
-#   define DDCLOG(a) do {} while (0)
-#endif /* !DEBUG_DISPLAY_CHANGE */
-
 extern int  hlpReportStatus(VBoxGuestFacilityStatus statusCurrent);
 extern void hlpReloadCursor(void);