Index: trunk/src/VBox/Runtime/common/string/nocrt-strdup.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/string/nocrt-strdup.cpp	(revision 96045)
+++ trunk/src/VBox/Runtime/common/string/nocrt-strdup.cpp	(revision 96045)
@@ -0,0 +1,42 @@
+/* $Id$ */
+/** @file
+ * IPRT - No-CRT Strings, strdup().
+ */
+
+/*
+ * Copyright (C) 2022 Oracle Corporation
+ *
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ *
+ * The contents of this file may alternatively be used under the terms
+ * of the Common Development and Distribution License Version 1.0
+ * (CDDL) only, as it comes in the "COPYING.CDDL" file of the
+ * VirtualBox OSE distribution, in which case the provisions of the
+ * CDDL are applicable instead of those of the GPL.
+ *
+ * You may elect to license modified versions of this file under the
+ * terms and conditions of either the GPL or the CDDL or both.
+ */
+
+
+/*********************************************************************************************************************************
+*   Header Files                                                                                                                 *
+*********************************************************************************************************************************/
+#define IPRT_NO_CRT_FOR_3RD_PARTY
+#include "internal/iprt.h"
+#include <iprt/string.h>
+
+
+#undef strdup
+char *RT_NOCRT(strdup)(const char *pszSrc)
+{
+    return RTStrDup(pszSrc);
+}
+RT_ALIAS_AND_EXPORT_NOCRT_SYMBOL(strdup);
+
Index: trunk/src/VBox/Runtime/common/string/nocrt-stricmp.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/string/nocrt-stricmp.cpp	(revision 96045)
+++ trunk/src/VBox/Runtime/common/string/nocrt-stricmp.cpp	(revision 96045)
@@ -0,0 +1,42 @@
+/* $Id$ */
+/** @file
+ * IPRT - No-CRT Strings, stricmp().
+ */
+
+/*
+ * Copyright (C) 2022 Oracle Corporation
+ *
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ *
+ * The contents of this file may alternatively be used under the terms
+ * of the Common Development and Distribution License Version 1.0
+ * (CDDL) only, as it comes in the "COPYING.CDDL" file of the
+ * VirtualBox OSE distribution, in which case the provisions of the
+ * CDDL are applicable instead of those of the GPL.
+ *
+ * You may elect to license modified versions of this file under the
+ * terms and conditions of either the GPL or the CDDL or both.
+ */
+
+
+/*********************************************************************************************************************************
+*   Header Files                                                                                                                 *
+*********************************************************************************************************************************/
+#include "internal/iprt.h"
+#include <iprt/string.h>
+
+
+#undef stricmp
+int RT_NOCRT(stricmp)(const char *psz1, const char *psz2)
+{
+    /* ASSUMES UTF-8 or plain ASCII input... The only alternative is to assume C locale. */
+    return RTStrICmp(psz1, psz2);
+}
+RT_ALIAS_AND_EXPORT_NOCRT_SYMBOL(stricmp);
+
Index: trunk/src/VBox/Runtime/common/string/nocrt-strtok.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/string/nocrt-strtok.cpp	(revision 96045)
+++ trunk/src/VBox/Runtime/common/string/nocrt-strtok.cpp	(revision 96045)
@@ -0,0 +1,42 @@
+/* $Id$ */
+/** @file
+ * IPRT - No-CRT Strings, strtok().
+ */
+
+/*
+ * Copyright (C) 2022 Oracle Corporation
+ *
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ *
+ * The contents of this file may alternatively be used under the terms
+ * of the Common Development and Distribution License Version 1.0
+ * (CDDL) only, as it comes in the "COPYING.CDDL" file of the
+ * VirtualBox OSE distribution, in which case the provisions of the
+ * CDDL are applicable instead of those of the GPL.
+ *
+ * You may elect to license modified versions of this file under the
+ * terms and conditions of either the GPL or the CDDL or both.
+ */
+
+
+/*********************************************************************************************************************************
+*   Header Files                                                                                                                 *
+*********************************************************************************************************************************/
+#include "internal/iprt.h"
+#include <iprt/string.h>
+
+
+#undef strtok
+char *RT_NOCRT(strtok)(char *psz, const char *pszDelimiters)
+{
+    static char *s_pszState = NULL; /** @todo make this a TLS variable. */
+    return RT_NOCRT(strtok_r)(psz, pszDelimiters, &s_pszState);
+}
+RT_ALIAS_AND_EXPORT_NOCRT_SYMBOL(strtok);
+
Index: trunk/src/VBox/Runtime/common/string/strcat.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/string/strcat.cpp	(revision 96045)
+++ trunk/src/VBox/Runtime/common/string/strcat.cpp	(revision 96045)
@@ -0,0 +1,53 @@
+/* $Id$ */
+/** @file
+ * IPRT - CRT Strings, strcat().
+ */
+
+/*
+ * Copyright (C) 2006-2022 Oracle Corporation
+ *
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ *
+ * The contents of this file may alternatively be used under the terms
+ * of the Common Development and Distribution License Version 1.0
+ * (CDDL) only, as it comes in the "COPYING.CDDL" file of the
+ * VirtualBox OSE distribution, in which case the provisions of the
+ * CDDL are applicable instead of those of the GPL.
+ *
+ * You may elect to license modified versions of this file under the
+ * terms and conditions of either the GPL or the CDDL or both.
+ */
+
+
+/*********************************************************************************************************************************
+*   Header Files                                                                                                                 *
+*********************************************************************************************************************************/
+#include "internal/iprt.h"
+#include <iprt/string.h>
+
+
+/**
+ * Append one string to another.
+ *
+ * @returns Pointer to destination string
+ * @param   pszDst      String to append @a pszSrc to.
+ * @param   pszSrc      Zero terminated string.
+ */
+#undef strcat
+char *RT_NOCRT(strcat)(char *pszDst, const char *pszSrc)
+{
+    char * const pszRet = pszDst;
+    pszDst = RTStrEnd(pszDst, RTSTR_MAX);
+    while ((*pszDst = *pszSrc++) != '\0')
+        pszDst++;
+
+    return pszRet;
+}
+RT_ALIAS_AND_EXPORT_NOCRT_SYMBOL(strcat);
+
Index: trunk/src/VBox/Runtime/common/string/strlen.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/string/strlen.cpp	(revision 96044)
+++ trunk/src/VBox/Runtime/common/string/strlen.cpp	(revision 96045)
@@ -41,5 +41,5 @@
 #ifdef IPRT_NO_CRT
 # undef strlen
-size_t strlen(const char *pszString)
+size_t RT_NOCRT(strlen)(const char *pszString)
 #elif RT_MSC_PREREQ(RT_MSC_VER_VS2005)
 __checkReturn size_t  __cdecl strlen(__in_z  const char *pszString)
Index: trunk/src/VBox/Runtime/common/string/strncat.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/string/strncat.cpp	(revision 96045)
+++ trunk/src/VBox/Runtime/common/string/strncat.cpp	(revision 96045)
@@ -0,0 +1,59 @@
+/* $Id$ */
+/** @file
+ * IPRT - No-CRT Strings, strncat().
+ */
+
+/*
+ * Copyright (C) 2006-2022 Oracle Corporation
+ *
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ *
+ * The contents of this file may alternatively be used under the terms
+ * of the Common Development and Distribution License Version 1.0
+ * (CDDL) only, as it comes in the "COPYING.CDDL" file of the
+ * VirtualBox OSE distribution, in which case the provisions of the
+ * CDDL are applicable instead of those of the GPL.
+ *
+ * You may elect to license modified versions of this file under the
+ * terms and conditions of either the GPL or the CDDL or both.
+ */
+
+
+/*********************************************************************************************************************************
+*   Header Files                                                                                                                 *
+*********************************************************************************************************************************/
+#include "internal/iprt.h"
+#include <iprt/string.h>
+
+
+/**
+ * Append a substring to an existing string.
+ *
+ * @returns Pointer to destination string
+ * @param   pszDst      String to append @a cchMaxSrc chars from @a pszSrc to,
+ *                      plus a zero terminator.
+ * @param   pszSrc      Zero terminated string.
+ * @param   cchMaxSrc   Maximum number of chars to copy from @a pszSrc.
+ */
+#undef strncat
+char *RT_NOCRT(strncat)(char *pszDst, const char *pszSrc, size_t cchMaxSrc)
+{
+    char * const pszRet = pszDst;
+
+    pszDst = RTStrEnd(pszDst, RTSTR_MAX);
+
+    char ch;
+    while (cchMaxSrc-- > 0 && (ch = *pszSrc++) != '\0')
+        *pszDst++ = ch;
+    *pszDst = '\0';
+
+    return pszRet;
+}
+RT_ALIAS_AND_EXPORT_NOCRT_SYMBOL(strncat);
+
Index: trunk/src/VBox/Runtime/common/string/strnlen.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/string/strnlen.cpp	(revision 96045)
+++ trunk/src/VBox/Runtime/common/string/strnlen.cpp	(revision 96045)
@@ -0,0 +1,52 @@
+/* $Id$ */
+/** @file
+ * IPRT - CRT Strings, strnlen().
+ */
+
+/*
+ * Copyright (C) 2006-2022 Oracle Corporation
+ *
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ *
+ * The contents of this file may alternatively be used under the terms
+ * of the Common Development and Distribution License Version 1.0
+ * (CDDL) only, as it comes in the "COPYING.CDDL" file of the
+ * VirtualBox OSE distribution, in which case the provisions of the
+ * CDDL are applicable instead of those of the GPL.
+ *
+ * You may elect to license modified versions of this file under the
+ * terms and conditions of either the GPL or the CDDL or both.
+ */
+
+
+/*********************************************************************************************************************************
+*   Header Files                                                                                                                 *
+*********************************************************************************************************************************/
+#include "internal/iprt.h"
+#include <iprt/string.h>
+
+
+/**
+ * Find the length of a zeroterminated byte string, but only up to a given
+ * limit.
+ *
+ * @returns String length in bytes, or cchMax if too long.
+ * @param   pszString   Zero terminated string.
+ * @param   cchMax      Max number of chars to search for the end.
+ */
+#undef strnlen
+size_t RT_NOCRT(strnlen)(const char *pszString, size_t cchMax)
+{
+    const char * const pszStart = pszString;
+    while (cchMax-- > 0 && *pszString)
+        pszString++;
+    return pszString - pszStart;
+}
+RT_ALIAS_AND_EXPORT_NOCRT_SYMBOL(strnlen);
+
Index: trunk/src/VBox/Runtime/common/string/strtok_r.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/string/strtok_r.cpp	(revision 96045)
+++ trunk/src/VBox/Runtime/common/string/strtok_r.cpp	(revision 96045)
@@ -0,0 +1,80 @@
+/* $Id$ */
+/** @file
+ * IPRT - No-CRT Strings, strtok_r().
+ */
+
+/*
+ * Copyright (C) 2022 Oracle Corporation
+ *
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ *
+ * The contents of this file may alternatively be used under the terms
+ * of the Common Development and Distribution License Version 1.0
+ * (CDDL) only, as it comes in the "COPYING.CDDL" file of the
+ * VirtualBox OSE distribution, in which case the provisions of the
+ * CDDL are applicable instead of those of the GPL.
+ *
+ * You may elect to license modified versions of this file under the
+ * terms and conditions of either the GPL or the CDDL or both.
+ */
+
+
+/*********************************************************************************************************************************
+*   Header Files                                                                                                                 *
+*********************************************************************************************************************************/
+#include "internal/iprt.h"
+#include <iprt/string.h>
+
+
+#undef strtok_r
+char *RT_NOCRT(strtok_r)(char *psz, const char *pszDelimiters, char **ppszState)
+{
+    /*
+     * Load state.
+     */
+    if (!psz)
+    {
+        psz = *ppszState;
+        if (!psz)
+            return NULL;
+    }
+
+    /*
+     * Skip leading delimiters.
+     */
+    size_t const cchDelimiters = strlen(pszDelimiters);
+    for (;;)
+    {
+        char ch = *psz;
+        if (!ch)
+            return *ppszState = NULL;
+        if (memchr(pszDelimiters, ch, cchDelimiters) == NULL)
+            break;
+        psz++;
+    }
+
+    /*
+     * Find the end of the token.
+     */
+    char * const pszRet = psz;
+    for (;;)
+    {
+        char ch = *++psz;
+        if (memchr(pszDelimiters, ch, cchDelimiters + 1 /* '\0' */) == NULL)
+        { /* semi-likely */ }
+        else
+        {
+            *psz = '\0';
+            *ppszState = ch ? psz + 1 : NULL;
+            return pszRet;
+        }
+    }
+}
+RT_ALIAS_AND_EXPORT_NOCRT_SYMBOL(strtok_r);
+